from CvPythonExtensions import *
import CvConfigParser
import zResource_Promos
import re

gc = CyGlobalContext()

pConfig = CvConfigParser.CvConfigParser("zResource Promos Config.ini")

class zResource_Promos:
	def __init__(self, eventManager):
		eventManager.addEventHandler("BeginPlayerTurn", self.onBeginPlayerTurn)
		eventManager.addEventHandler("unitBuilt", self.onUnitBuilt)
		eventManager.addEventHandler("GameStart", self.onGameStart)
		eventManager.addEventHandler("OnLoad", self.onLoadGame)

	def onGameStart(self, argsList):
		'Called at the start of the game'
		self.unitClasses = dict()

		print "-->%d" %(gc.getNumBonusInfos())

		for iUnit in range(gc.getNumUnitClassInfos()):
			pUnit = gc.getUnitInfo(iUnit)
			pUnitClass = gc.getUnitClassInfo(pUnit.getUnitClassType())
			for iBonus in range(gc.getNumBonusInfos()):
				pBonus = gc.getBonusInfo(iBonus)
				szPromotion = pConfig.get(pUnit.getType(), pBonus.getType(), "")

				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getDescription(), pBonus.getType(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getType(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getDescription(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getDescription(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getType(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getType(), pBonus.getType(), "")

				if szPromotion != "":
					bInsideBorders = False
					if szPromotion.find(",") >= 0:
						szInsideBorders = szPromotion.split(",")[1].lower()
						szPromotion = szPromotion.split(",")[0]
						if szInsideBorders.find("true") >= 0 or szInsideBorders.find("yes") >= 0 or szInsideBorders.find("1") >= 0 or szInsideBorders.find("ok") >= 0:
							bInsideBorders = True
					self.addUnitClassPromotion(pUnitClass.getType(), pBonus.getType(), szPromotion, bInsideBorders)

	def onLoadGame(self, argsList):
		self.unitClasses = dict()

		print "-->%d" %(gc.getNumBonusInfos())

		for iUnit in range(gc.getNumUnitClassInfos()):
			pUnit = gc.getUnitInfo(iUnit)
			pUnitClass = gc.getUnitClassInfo(pUnit.getUnitClassType())
			for iBonus in range(gc.getNumBonusInfos()):
				pBonus = gc.getBonusInfo(iBonus)
				szPromotion = pConfig.get(pUnit.getType(), pBonus.getType(), "")

				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getDescription(), pBonus.getType(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getType(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnit.getDescription(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getDescription(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getType(), pBonus.getDescription(), "")
				if szPromotion == "":
					szPromotion = pConfig.get(pUnitClass.getType(), pBonus.getType(), "")

				if szPromotion != "":
					bInsideBorders = False
					if szPromotion.find(",") >= 0:
						szInsideBorders = szPromotion.split(",")[1].lower()
						szPromotion = szPromotion.split(",")[0]
						if szInsideBorders.find("true") >= 0 or szInsideBorders.find("yes") >= 0 or szInsideBorders.find("1") >= 0 or szInsideBorders.find("ok") >= 0:
							bInsideBorders = True
					self.addUnitClassPromotion(pUnitClass.getType(), pBonus.getType(), szPromotion, bInsideBorders)
		return 0


	def addUnitClassPromotion(self, szUnitclass, szBonus, szPromotion, bInsideBorders):
		found = False
		didChange = False
		for iPromo in range(gc.getNumPromotionInfos()):
			if gc.getPromotionInfo(iPromo).getType() == szPromotion:
				found = True
				break
			elif gc.getPromotionInfo(iPromo).getDescription() == szPromotion:
				found = True
				didChange = True
				szPromotion = gc.getPromotionInfo(iPromo).getType()
				break

		if found == False:
			szPromotion = "PROMOTION_" + szPromotion

		if not self.unitClasses.has_key(szUnitclass):
			self.unitClasses[szUnitclass] = dict()
			print "Created an entry w/ %s, %s, %s, %s" %(szUnitclass, szBonus, szPromotion, str(bInsideBorders))

		self.unitClasses[szUnitclass][szBonus] = (szPromotion, bInsideBorders)

	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		iGameTurn, iPlayer = argsList

		pPlayer = gc.getPlayer(iPlayer)

		for iUnit in range(pPlayer.getNumUnits()):
			pUnit = pPlayer.getUnit(iUnit)
			type = gc.getUnitClassInfo(pUnit.getUnitClassType())
			if type != None:
				type = gc.getUnitClassInfo(pUnit.getUnitClassType()).getType()
				if self.unitClasses.has_key(type):
					for szPromo in self.unitClasses[type]:
						if pUnit.plot().getOwner() == pUnit.getOwner() or not self.unitClasses[type][szPromo][1]:
							if pPlayer.getNumAvailableBonuses(gc.getInfoTypeForString(szPromo)) > 0:
								pUnit.setHasPromotion(gc.getInfoTypeForString(self.unitClasses[type][szPromo][0]), True)

	def onUnitBuilt(self, argsList):
		'Unit Completed'
		city = argsList[0]
		unit = argsList[1]
		pPlayer = gc.getPlayer(city.getOwner())

		type = gc.getUnitClassInfo(unit.getUnitClassType())
		if type != None:
			type = gc.getUnitClassInfo(unit.getUnitClassType()).getType()
			if self.unitClasses.has_key(type):
				for szPromo in self.unitClasses[type]:
					if pPlayer.getNumAvailableBonuses(gc.getInfoTypeForString(szPromo)) > 0:
						unit.setHasPromotion(gc.getInfoTypeForString(self.unitClasses[type][szPromo]), True)